package main

import (
	"fmt"

	"github.com/beego/beego/v2/server/web"
)

// 定义 Controller
type CityController struct {
	web.Controller
}

// Restfull API
func (c *CityController) Get() {
	c.Ctx.WriteString(`{"data": 123}`)
}

func (c *CityController) Create() {
	c.Ctx.WriteString(c.Ctx.Request.Method)
}

func (c *CityController) Put() {

}

func (c *CityController) Delete() {

}

type RegexpController struct {
	web.Controller
}

func (c *RegexpController) Get() {
	c.Ctx.WriteString(c.Ctx.Input.Param(":id"))
}

type AutoController struct {
	web.Controller
}

func (c *AutoController) Test() {
	c.Ctx.WriteString(fmt.Sprintf("%s method: %s", "test", c.Ctx.Request.Method))
}

func main() {
	// url 和控制器绑定，默认匹配Get/Post/Put等方法
	//web.Router("/city/", &CityController{})
	// 自定义路由和函数Map
	web.Router("/city/", &CityController{}, "GET:Get;post:Create")
	// 正则路由
	web.Router("/regexp/?:id/", &RegexpController{})
	// 自动路由，自动将路由绑定到 "/auto/"，/auto/test 自动将所有请求类型绑定到 Test 方法上
	web.AutoRouter(&AutoController{})

	web.Run()
}
